from .base import get_collection, get_db, UnknownTaskError
from .workerutils import update_task

db = get_db()


def queue_task(sessid, task_name, *args, **kwargs):
    task_id = get_collection(db).insert({
        'session_id': sessid,
        'name': task_name,
        'args': args,
        'kwargs': kwargs,
    })
    update_task(task_id, 'queued')

    return task_id


def get_task(task_id):
    task = get_collection(db).find_one({'_id': task_id})
    if not task:
        raise UnknownTaskError(task_id)
    return task
