import time
import os

from .base import get_collection, get_db, update_task as base_update_task


last_queued = None

db = get_db()


def next_task():
    """
    Will poll until a new task shows up. Polling is very aggressive here.
    """
    while True:
        q = {'status': 'queued'}
        task = get_collection(db).find_one(q, sort=[('_id', 1)])
        if task:
            return task
        time.sleep(0.2)


def update_task(*args, **kwargs):
    return base_update_task(*args, db=db, **kwargs)


def getpid(pidfile):
    if not os.path.exists(pidfile):
        return None
    with open(pidfile) as fh:
        try:
            return int(fh.read())
        except ValueError:
            return None


def is_running(pid):
    try:
        os.getpgid(pid)
        return True
    except Exception:
        pass
    return False
